class Count(val c: Int)

fun getResultFunction(status: String): (Count) -> Int {
   	if (status == "VIP") {
		return {
			count -> 10 + 20 * count.c
		}
   	}
    return {
		count -> 10 * count.c
	}
}

fun main(args : Array<String>) { 
	val c1 = getResultFunction("VIP")
	var count = Count(12)
	println("Result: ${c1(count)}")
	
	val c2 = getResultFunction("REGULAR")
	println("Result: ${c2(count)}")
}
