fun returnInt(a:Int, b:Int, f: (Int, Int) -> Int): Int {
	return f.invoke(a, b)
}

fun returnDouble(a:Int, b:Int, f: (Int, Int) -> Double): Double {
	return f.invoke(a, b)
}

fun main(args : Array<String>) { 

	var fInt = fun (a1:Int, a2:Int): Int { return a1+a2 }
	var fDouble = fun (a1:Int, a2:Int): Double { return a1.toDouble()+a2 }

	println(returnInt(3, 4, fInt))
	println(returnDouble(3, 4, fDouble))

	println(returnInt(1, 3, {a, b -> a+b} ))
	println(returnInt(1, 3, {a, b -> a-b} ))
	println(returnInt(1, 3, {a, b -> a*b} ))

	println(returnDouble(4, 3, {a, b -> a.toDouble()/b} ))
	println(returnInt(4, 3, {a, b -> a/b} ))

}
