fun main(args : Array<String>) { 
    if (args.size != 1) {
        println("Please give me just one argument!")
        return
    }

	var n: Int 
	val k = args[0]
    try {
        n = k.toInt()
		if (n < 0) {
			println("Provide a positive integer: $n")
			return
		}
        println("Calculating $n!")
    }
    catch (e: NumberFormatException) {
        println("Cannot use $k")
        return
    }

	var product = 1
	(1..n).forEach { product *= it}
	println(product)
}
